VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   4065
   ClientLeft      =   2835
   ClientTop       =   1230
   ClientWidth     =   5625
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   271
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   375
   Begin VB.Label lblDistance 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "Click twice to define a segment and then once more to select a point."
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_X(0 To 2) As Single
Private m_Y(0 To 2) As Single
Private m_NextPoint As Integer
' Calculate the distance between the point and the segment.
Private Function DistToSegment(ByVal px As Single, ByVal py As Single, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByRef near_x As Single, ByRef near_y As Single) As Single
Dim dx As Single
Dim dy As Single
Dim t As Single

    dx = X2 - X1
    dy = Y2 - Y1
    If dx = 0 And dy = 0 Then
        ' It's a point not a line segment.
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
        DistToSegment = Sqr(dx * dx + dy * dy)
        Exit Function
    End If

    ' Calculate the t that minimizes the distance.
    t = ((px - X1) * dx + (py - Y1) * dy) / (dx * dx + dy * dy)

    ' See if this represents one of the segment's
    ' end points or a point in the middle.
    If t < 0 Then
        dx = px - X1
        dy = py - Y1
        near_x = X1
        near_y = Y1
    ElseIf t > 1 Then
        dx = px - X2
        dy = py - Y2
        near_x = X2
        near_y = Y2
    Else
        near_x = X1 + t * dx
        near_y = Y1 + t * dy
        dx = px - near_x
        dy = py - near_y
    End If

    DistToSegment = Sqr(dx * dx + dy * dy)
End Function
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dist As Single
Dim near_x As Single
Dim near_y As Single

    If m_NextPoint = 3 Then
        Me.Cls
        m_NextPoint = 0
    End If

    m_X(m_NextPoint) = X
    m_Y(m_NextPoint) = Y
    Me.Circle (X, Y), 3

    If m_NextPoint = 1 Then
        Me.Line (m_X(0), m_Y(0))-(m_X(1), m_Y(1))
    ElseIf m_NextPoint = 2 Then
        dist = DistToSegment(m_X(2), m_Y(2), m_X(0), m_Y(0), m_X(1), m_Y(1), near_x, near_y)
        lblDistance.Caption = Format$(dist, "0.00")
        Me.Circle (near_x, near_y), 3, vbBlue
        Me.Line (near_x, near_y)-(m_X(2), m_Y(2)), vbBlue
    End If

    m_NextPoint = m_NextPoint + 1
End Sub
